searchNodes=[{"ref":"Comeonin.html","title":"Comeonin","type":"behaviour","doc":"Defines a behaviour for higher-level password hashing functions."},{"ref":"Comeonin.html#c:add_hash/2","title":"Comeonin.add_hash/2","type":"callback","doc":"Hashes a password and returns the password hash in a map, with the password set to nil. In the default implementation, the key for the password hash is :password_hash. A different key can be used by using the hash_key option. Example with Ecto The put_pass_hash function below is an example of how you can use add_hash to add the password hash to the Ecto changeset. defp put_pass_hash(%Ecto.Changeset{valid?: true, changes: %{password: password}} = changeset) do change(changeset, add_hash(password)) end defp put_pass_hash(changeset), do: changeset This function will return a changeset with %{password_hash: password_hash, password: nil} added to the changes map."},{"ref":"Comeonin.html#c:check_pass/3","title":"Comeonin.check_pass/3","type":"callback","doc":"Checks the password by comparing its hash with the password hash found in a user struct, or map. The first argument to check_pass should be a user struct, a regular map, or nil. In the default implementation, if the input to the first argument, the user struct, is nil, then the no_user_verify function is run, so as to prevent user enumeration. This can be disabled by setting the hide_user option to false. Example The following is an example of calling this function with no options: def verify_user(%{&quot;password&quot; =&gt; password} = params) do params |&gt; Accounts.get_by() |&gt; check_pass(password) end The Accounts.get_by function in this example takes the user parameters (for example, email and password) as input and returns a user struct or nil. If your user map stores the password in the key :pw_hash instead of the default password_hash, you can do case check_pass(user, hash_key: :pw_hash) do {:ok, user} -&gt; # user is not nil and the password is verified {:ok, user} {:error, msg} -&gt; # User was nil or the password did not hash to the value in :pw_hash. # The string value of msg will tell you which. {:error, msg} end"},{"ref":"Comeonin.html#c:no_user_verify/1","title":"Comeonin.no_user_verify/1","type":"callback","doc":"Runs the password hash function, but always returns false. This function is intended to make it more difficult for any potential attacker to find valid usernames by using timing attacks. This function is only useful if it is used as part of a policy of hiding usernames. Hiding usernames In addition to keeping passwords secret, hiding the precise username can help make online attacks more difficult. An attacker would then have to guess a username / password combination, rather than just a password, to gain access. This does not mean that the username should be kept completely secret. Adding a short numerical suffix to a user&#39;s name, for example, would be sufficient to increase the attacker&#39;s work considerably. If you are implementing a policy of hiding usernames, it is important to make sure that the username is not revealed by any other part of your application."},{"ref":"Comeonin.html#t:opts/0","title":"Comeonin.opts/0","type":"type","doc":""},{"ref":"Comeonin.html#t:password/0","title":"Comeonin.password/0","type":"type","doc":""},{"ref":"Comeonin.html#t:user_struct/0","title":"Comeonin.user_struct/0","type":"type","doc":""},{"ref":"Comeonin.BehaviourTestHelper.html","title":"Comeonin.BehaviourTestHelper","type":"module","doc":"Test helper functions for Comeonin behaviours."},{"ref":"Comeonin.BehaviourTestHelper.html#add_hash_creates_map/2","title":"Comeonin.BehaviourTestHelper.add_hash_creates_map/2","type":"function","doc":"Checks that the add_hash function creates a map with the password set to nil and the password_hash correctly set."},{"ref":"Comeonin.BehaviourTestHelper.html#ascii_passwords/0","title":"Comeonin.BehaviourTestHelper.ascii_passwords/0","type":"function","doc":"List of passwords that just contain basic ascii characters."},{"ref":"Comeonin.BehaviourTestHelper.html#check_pass_nil_user/1","title":"Comeonin.BehaviourTestHelper.check_pass_nil_user/1","type":"function","doc":"Checks that the check_pass function returns an error when no user is found."},{"ref":"Comeonin.BehaviourTestHelper.html#check_pass_returns_error/2","title":"Comeonin.BehaviourTestHelper.check_pass_returns_error/2","type":"function","doc":"Checks that the check_pass function returns an error for incorrect passwords."},{"ref":"Comeonin.BehaviourTestHelper.html#check_pass_returns_user/2","title":"Comeonin.BehaviourTestHelper.check_pass_returns_user/2","type":"function","doc":"Checks that the check_pass function returns the user for correct passwords."},{"ref":"Comeonin.BehaviourTestHelper.html#correct_password_true/2","title":"Comeonin.BehaviourTestHelper.correct_password_true/2","type":"function","doc":"Checks that the verify_pass function returns true for correct password."},{"ref":"Comeonin.BehaviourTestHelper.html#non_ascii_passwords/0","title":"Comeonin.BehaviourTestHelper.non_ascii_passwords/0","type":"function","doc":"List of passwords that contain non-ascii characters."},{"ref":"Comeonin.BehaviourTestHelper.html#wrong_password_false/2","title":"Comeonin.BehaviourTestHelper.wrong_password_false/2","type":"function","doc":"Checks that the verify_pass function returns false for incorrect passwords."},{"ref":"Comeonin.PasswordHash.html","title":"Comeonin.PasswordHash","type":"behaviour","doc":"Defines a behaviour for password hashing functions."},{"ref":"Comeonin.PasswordHash.html#c:hash_pwd_salt/2","title":"Comeonin.PasswordHash.hash_pwd_salt/2","type":"callback","doc":"Generates a random salt and then hashes the password."},{"ref":"Comeonin.PasswordHash.html#c:verify_pass/2","title":"Comeonin.PasswordHash.verify_pass/2","type":"callback","doc":"Checks the password by comparing it with a stored hash. Please note that the first argument to verify_pass should be the password, and the second argument should be the password hash."},{"ref":"Comeonin.PasswordHash.html#t:opts/0","title":"Comeonin.PasswordHash.opts/0","type":"type","doc":""},{"ref":"Comeonin.PasswordHash.html#t:password/0","title":"Comeonin.PasswordHash.password/0","type":"type","doc":""},{"ref":"Comeonin.PasswordHash.html#t:password_hash/0","title":"Comeonin.PasswordHash.password_hash/0","type":"type","doc":""}]